% Matthew Gentzkow
% February 17, 2002
%
% testmats
% 
% This function compares matrices A and B, returning a new matrix TEST
% where TESTij==1 if Aij==Bij and TESTij==0 otherwise. Note that the
% dimensions of A and B must be the same.

function TEST = testmats(A,B)

% check for errors
if size(A)~=size(B), error('Matrices must have the same dimensions'), end

TEST = sign(-abs(A-B))+1;