!subroutine likel(first_call, param, finish, f, objgrad)
subroutine likel(mode, n, paramall, f, objgrad, nstate, iuser, user)
				  
            
use proglo
use paramglo
!use nag_nlp
!use nag_f77_e_chapter  
!use nag_f77_s_chapter                

implicit none
!real(kind=ikind), dimension(npointe):: pe
!real*8 betap(maxpar)
logical::first_call,finish
!real*8 theta(maxpar1)
real*8 vss,vww, f,probq, xbeta,diff,fi,pga, ppi,wtheta,grth,yrsth,ageth,pga1,grth1, feduc, xbeduc
integer i, nstate,mode,n,ij,j,jk,ie,ntheta,ij1 !,iuser
integer nprob1, nprob0, nparam1,n1,n2, npar, ifail
integer:: iuser(*)
real(kind=ikind):: user(*)
real*8 paramall(*), param(maxpar)
!real(kind=ikind),intent(in)::param(:)
real*8 objgrad(*)
real*8 lnfact, xie, meanp, meanp1, fmax, fmin, xbm, ffm, lcut, rcut, load , s15abf
real*8 pareduc(maxpar)
real*8 fff(nobs)
!external s15abf
!write(77,*) ' begin of likel'
if(deriva.gt.0) then 
	n1=observ
	n2=observ
else
	n1=1
	n2=nobs
endif

load=paramall(1)
!  points of support Education
if(npoints.gt.1) then
	do i = 1,npoints
	   xpointe(i) = load*paramall(i+1)
	enddo
endif
!  points of support Intercept
do i=1,npoints
	xpoint(i)=paramall(1+i)
enddo

!  points of support Wage
do j=1,npointi
	xpointi(j)=paramall(1+npoints+j)
enddo 

probp(npoints,npointi)=0.d0
ij=0

do i=1,npoints
	do j=1,npointi
		if(i.eq.npoints.and.j.eq.npointi ) then
			continue
		else
			ij=ij+1
			probp(i,j)=dexp(paramall(1+npoints+npointi+ij))
			probp(npoints,npointi)=probp(npoints,npointi)+probp(i,j)
	!		if(imode.eq.1) write(6,*) i,j,ie,probp(i,j,ie), probp(npoints,npointi,npointe)
		endif
	enddo
enddo


!write(6,*) probp(npoints,npointi,npointe)
! assign parameters: the order is as follows
!  points of support for the unobs het. in education (pointe-1 : the last guarantees zero mean)
!  points of support for the unobs het. in intercept (of cost fucntion) (no zero mean here)
!  points of support for the unobvs het in slopes (coeff in wage) (no zero mean here)
!  npoints*npointi*npointe-1 probabilities 
!  cutoffs point in the ordered probit for the education (initial condition) equation: nschool-1
!  variables in the education (initial condition) equation
!  parameters of cost function (varying depending on how many vars)
!  parameter on the grant (always): notice when there are only control is not identified
!  parameter on  age in the cost function (if useage=1 :: ageth)
!  parameter on age*grant (if useg_a=1:  pga)
!  paramater on yrs of educ in the cost function (if useyrs=1:: yrsth)






do i =1,npoints
	do j=1,npointi
		if(i.eq.npoints.and.j.eq.npointi ) then
			continue
		else
	!	    write(6,*) 'before' , i,j,ie, probp(i,j,ie)
			probp(i,j)=probp(i,j)/(1+probp(npoints,npointi))
		endif
			if(imode.eq.1) write(6,*) 'division',i,j,ie,probp(i,j)

	enddo
enddo


probp(npoints,npointi)=1/(1+probp(npoints,npointi))
 





nparam1=3+nconst+nprim+nsec+useage+useg_a+useyrs

ij=npoints+npointi+1+(npoints*npointi)

! Now parameters in the education equation
ij1=0
do i=selage,final-1
	do j=1,i-6
		if(j.eq.1) then
			cutoff(i-selage+1,j)=paramall(ij+ij1)
		else
			!paramall(ij+ij1)=log(paramall(ij+ij1)-cutoff(i-selage+1,j-1))
			cutoff(i-selage+1,j)=cutoff(i-selage+1,j-1)+dexp(paramall(ij+ij1))
		endif
		ij1=ij1+1
	enddo 
enddo
!write(77,*) ' cutoffs assigned' 
ij=ij+ncuts

do i=ij,ij+npeduc-1
   pareduc(i-ij+1) = paramall(i)
enddo

ij = ij + npeduc

!Now parameters of the terminal value function
if(nparterm.gt.0) then
	do i=ij,ij+nparterm-1
		pt(i-ij+1) = paramall(i)
	enddo
endif

ij=ij+nparterm

! I put +2 because the first of thetal is the incercept that is assigned below.

do i=ij,nparam-1-useage-useg_a-useyrs
	thetal(i-ij+2)=paramall(i)
enddo
!I think this is wrong: The +1 should be removed. CHECKED - LOOKED OK (14/9/01)
ntheta=nparam-useage-useg_a-useyrs-ij+1
ij=nparam-useage-useg_a-useyrs

grth1=paramall(ij)
ij=ij+1

if(useage.eq.1) then
	ageth=paramall(ij)
	ij=ij+1
else
	ageth=0
endif

!write(6,*) ' flag pass'

f=0.d0
xbeta=0.
nprob1=0
nprob0=0


if (useg_a.eq.1) then
	pga1=paramall(ij)
	ij=ij+1
else
	pga1=0.d0
endif


if(useyrs.eq.1) then
	yrsth=paramall(ij)
	ij=ij+1
else
	yrsth=0.d0
endif



if(imode.eq.1) then 

	write(6,*) ' parameters as assigned '

!	write(6,*) 'points of education' 
!	do ij=1,npointe
!		write(6,*) xpointe(ij)
!	enddo
!write(6,*) 'pe', (pe(j),j=1,npointe)

	write(6,*) 'points of intercept' 
	do ij=1,npoints
		write(6,*) xpoint(ij)
	enddo

	write(6,*) 'points of wage heterogeneity' 
	do ij=1,npointi
		write(6,*) xpointi(ij)
	enddo

	write(6,*) 'probability distribution '
	ij=0
!	do ie=1,npointe
	do i = 1, npoints
		do j=1, npointi
			ij=ij+1
			write(6,*) i,j,probp(i,j),paramall(ij+npoints+npointi+1)
		enddo
	enddo
!	enddo

    write(6,*) ' cutoff points for the o-probit of initial conditions'

	do i=selage, final-1
		do j=1,i-6
			write(6,*) i,j,cutoff(i-selage+1,j)
		enddo 
	enddo
	write(6,*) ' pareduc'
	do i=1,npeduc
		write(6,*) i,pareduc(i) 
	enddo
	write(6,*) 'parameters of the value function'
	write(6,*) pt(1),pt(2)
	write(6,*) 'cost variables 0 in the first to be filled'
	do i=1,ntheta
		write(6,*) i,thetal(i)
	enddo

	write(6,*) 'grant paramter = ',grth1

	if(useage.eq.1) then
		write(6,*) ' age param = ',ageth
	endif
	if(useg_a.eq.1) then
		write(6,*) ' age*grant param = ',pga1
	endif
	if(useyrs.eq.1) then
		write(6,*) ' yrs param = ',yrsth
	endif
 
endif

call terminal
if(imode.eq.1) write(6,*) ' ob loop',n1,n2

!ffm=0.d0
!xbm=0.d0
!write(77,*) ' starting obs loop'
iflag=0
do i=n1,n2
	!write(77,*) ' i = ', i
	fi=0.d0
	ppi=0.d0
	!fmax=0.d0
	!fmin=0.d0
	if (age(i).ge.lowerage) then

		call educind(pareduc,npeduc,xbeduc,i)
		!if(i.le.2) write(77,*) ' flag2'
		ifail=1

		if(grade(i).eq.1) then
			lcut=-100
			rcut= cutoff(age(i)-selage+1, grade(i))
		endif
 
	    if (grade(i).eq.(age(i)-5).and.grade(i).gt.1) then
			lcut= cutoff(age(i)-selage+1, grade(i)-1)
			rcut=100
		endif

		if (grade(i).lt.(age(i)-5).and.grade(i).gt.1) then
			lcut= cutoff(age(i)-selage+1, grade(i)-1)
			rcut= cutoff(age(i)-selage+1, grade(i))
		endif

		do j =1,npoints  !loop for education heterogeneity
	
			meanp = -xbeduc + xpointe(j) + lcut
		    meanp1 = -xbeduc + xpointe(j) + rcut

			if (meanp1.lt.meanp.and.imode.eq.1) then
			    write(6,*) ' warning meanp1 smaller than meanp', meanp1, meanp
				write(6,*) ' age grade cutoffs' , age(i), grade(i), cutoff(age(i)-selage+1, grade(i)), cutoff(age(i)-selage+1, grade(i)+1)
			endif
			!if(i.le.2) write(77,*) ' flag3'

			feduc=s15abf(meanp1,ifail)-s15abf(meanp,ifail)

			!fff(i)=feduc
			!xbm=xbm+xbeduc/n2
			!ffm=ffm+feduc/n2
			!if(feduc.ge.fmax) fmax=feduc
			!if(feduc.le.fmin) fmin=feduc

			!if (imode.eq.1) write(77,*) i,fff(i), grade(i), age(i), lcut, rcut

				!poisson density :
				!lnfact = 0
			!do ie = 1, grade(i)-1
			!   xie = ie
			!  lnfact = lnfact + log(xie)
			!enddo

			!feduc =-meanp + (grade(i)-1)*log(meanp) - lnfact ! -1 because we have added 1 in the data to the education level
		    !feduc = exp(feduc)

			thetal(1)=xpoint(j)
				
			call costmath(thetal,ageth,yrsth,i)

			!if(i.le.2) write(77,*) ' flag4 npoints ' , j

			do jk=1,npointi  !loop for wage and grant effect heterogeneity
				wtheta=xpointi(jk)
			    grth=grth1 * wtheta
				pga = pga1 * xpointi(jk) 
				!write(6,*) (thetal(ij),ij=1,nparam)
				call value(age(i),grade(i),benef(i),fben(i),village(i),vss,vww,i,wtheta,grth,pga,j,jk)
			!               (agei,gradei,ben,benf,vill,vss,vww,             indiv,wtheta,       progth,        progtha)

				diff=vss-vww
				if(diff.lt.-lz) then
					nprob0 = nprob0+1
				diff=-lz
				endif

				if(diff.gt.-lz1) then
					diff=-lz1
					nprob1 = nprob1 + 1
				endif
 
				probq=1/(1+exp(-diff))
!feduc=1
		        if (estimat .eq. 0) ppi = ppi + probq*probp(j,jk) !*feduc

				if (abs(enrol(i)-1.) .le. zero) then
					fi=fi+probp(j,jk)*probq*feduc
				else
					fi=fi+probp(j,jk)*(1-probq)*feduc
				endif
 !   if(i.le.20) write(6,*) 'i etc ',i,fi,probp(j)


			enddo !npointi
		enddo !npoints
!enddo !npointe
		if (estimat .eq. 0) probab(i) = ppi

		if (fi .le. 0) then
			!write(6,*) 'fi < 0 ', fi
			!stop
			fi = 1.0e-30
		endif

	    fi=log(fi)
	endif
	f=f+fi
       

!if (nstate .eq. 1) xbeta=xbeta+(vss-vww)
!if(i.le.5.and.(vww.eq.0.or.vss.eq.0)) write(6,100)i, xbeta,vss,vww
enddo
!write(77,*) ' end of obs loop'
f=-f

!if (imode .eq. 1) then 
   !xbeta=xbeta/nobs
!   write(6,*) ' average index = ',xbm
!	write(6,*) ' average probability', ffm
!	write(6,*) ' max probability ',fmax
!	write(6,*) ' min prob ' , fmin
!     xbm=1.96
!	 write(6,*) ' test s15abf' , s15abf(xbm,ifail)
!endif

!if (nprob0 .gt. 0) write(6,*) 'probabilities close to zero', nprob0
!if (nprob1 .gt. 0) write(6,*) 'probabilities close to one' , nprob1

!write(77,*) ' end of likel'
rewind(77)
!do i=1,nparam
!write(77,*) paramall(i)
!enddo


return
100 format(1x,'xb',i4,3f12.5)
1002 format(1x,2i4,1f12.5)
1001 format(1x,i4,2f12.5)

end