program progresa_educ

!use nag_f77_d_chapter
!use nag_f77_e_chapter
!use nag_f77_s_chapter
!use nag_f77_x_chapter
!use nag_quad_util
!use nag_nlp, only:nag_nlp_sol,nag_nlp_cntrl_init, &
! & nag_nlp_cntrl_wp =>nag_nlp_cntrl_dp,nag_error,nag_set_error

use proglo

use paramglo

implicit none



logical::obj_deriv
real(kind=ikind),dimension(maxpar) ::objgrad,x_lower,x_upper,theta
!real(kind=ikind),dimension(nparam)::obj_grad,x_lower,x_upper,theta

real(kind=ikind) :: funct, sum1, xval, hbase, rsquare, rss
real*8 vs1,vw1,xx,uno, sumsc, deltar, sumsa
integer nclin, ncnln, lda, ldcj, ldr, iter, ifail, idim, idim1, ibeta, np, nder, ia , na, ii
integer ik21,ik31, ik30, jjj, kkk, jj1, kk1, bprob, eprob, jprob, nprob, testgrant
integer, dimension(3*maxpar) :: istate, iuser, index
integer, dimension(3*maxpar) :: IWK
real(kind=ikind), dimension(3*maxpar) :: bl, bu, c, clamda, user
real(kind=ikind), dimension(maxpar, maxpar) ::  a,cjac, r, cov, w, covsc, hess, covsa, xxsc, gslab_R, gslab_hess
real(kind=ikind), dimension(21*maxpar) :: work
real(kind=ikind), dimension(maxpar) :: mscore
real(kind=ikind), dimension(14) :: der, erest
real(kind=ikind) , dimension(10)::pi,pj
real(kind=ikind) , dimension(20,20)::vprob,vprobsc, vprobsa, vp, vpsc, vpsa, gprob

real(kind=ikind) , dimension(20)::ppp


REAL(KIND=IKIND), DIMENSION(MAXPAR)::TAU
character*12 :: nvar
logical::first_call,finish
integer::unit,ij,i,jk, j, mode, nstate, ik, ik1,nparam1,ik2,ik3,ik4,ik5,ik6,ik7
integer::major_iter_lim,icou
integer::minor_iter_limx,ie
integer, dimension(7):: itime
real(kind=ikind),dimension(maxpar):: bbb, lambda
!real(kind=ikind),dimension(maxpar)::theta
!type(nag_nlp_cntrl_wp):: control
!type(nag_error)::error


!EXTERNAL costas, likel, likfun
EXTERNAL costas, likel, FUNDER

lz=log(1/zero-1)
lz1=log(1/(1-zero)-1)
grant=rgrant
call readdata
! call terminal NOW CALLED IN LIKEL
!allocate(obj_grad(nparam))
!allocate(x_lower(nparam))
!allocate(x_upper(nparam))
!allocate(theta(nparam))

! number of cutoff parameters in the order probit
ncuts=0
do ie=selage,final-1
    ncuts=ncuts+ie-6
    !nc(ie-selage+1)=ie-6
enddo



if (estimat.eq.0) goto 10001

do ibeta=1,ndiscfact ! ndiscfact currently fixed at 1

    write(6,*) "A"
    obj_deriv=.false.
    first_call=.true.
    finish=.false.
    x_upper= -1.d10
    x_lower=-1.d10



    !call nag_nlp_cntrl_init(control)
    !control%major_iter_lim=200
    !control%minor_iter_lim=200
    !control%unit=2

    !vs1=0.2
    !vw1=0.3
    !call expmax(vs1,vw1,xx)
    !write(6,*) ' vs vw xx'
    !write(6,*) vs1,vw1,xx
    !vw1=0.4
    !call expmax(vs1,vw1,xx)
    !write(6,*) ' vs, vw , xx '
    !write(6,*) vs1,vw1,xx
    !stop
    !do ibeta=1,ndiscfact
    beta=betas(ibeta)


    !beta = 0.9
    !betadj = betadjs(ibeta)
    grant=rgrant

    write(6,*) '                                            '
    write(6,*) '                                            '

    write(6,*) '*****************************************'
    write(6,*) 'discount factor in this run is ', beta
    write(7,*) '                                            '
    write(7,*) '                                            '
    write(7,*) '                                            '

    write(7,*) '*****************************************'
    write(7,*) 'discount factor in this run is ', beta
    deriva=0
    if(nparterm.eq.0) call terminal

    !call nag_set_error(error)
    !write(6,*) (theta0(i),i=1,nparam)

    !if (ibeta.lt.2) then

    do i=1,nparam
        theta(i)=theta0(i)
    enddo


    write(6,*) 'grant'
    write(6,1004) grant
    1004 format(8f5.1)

    nstate=1

    !write(6,*) (theta(i),i=1,nparam)
    write(6,*)  'now call likelihood function'


    imode=1
    call x05aaf(itime)
    write(6,*) ' time is ',(itime(ij),ij=1,7)
    mode = 1
    call likel(mode, nparam, theta, funct, objgrad,  nstate, iuser, user)
    !call likel(first_call,nparam, theta, finish, funct, objgrad)
    call x05aaf(itime)

    write(6,*) ' time is ',(itime(ij),ij=1,7)
    write(6,*) ' function value = ',funct
    write(6,*) ' just before entering nag'
    !do ij=1,nparam
    !write(6,*) theta(ij)
    !enddo
    !endif

    imode=0
    mode=2
    nstate=1
    nclin=0
    ncnln=0
    lda=maxpar
    ldcj=maxpar
    ldr = maxpar

    idim = 3*maxpar
    idim1 = 21*maxpar

    ifail = -1

    do ij=1,maxpar
        istate(ij) = 0
        bl(ij) = -70.
        bu(ij) =  70.
    enddo

    !Switch off the cutoffs for the 17 year olds who are now excluded because we do not observe their education activity
    do ij=57,67
        bl(ij)=0
        bu(ij)=0
        istate(ij) = 3
    enddo

    if(progin.eq.0) then
        bl(nparam-1)=0.d0
        bu(nparam-1)=0.d0
        istate(nparam-1)=3
    endif

    if (notreat .eq. 1) then
        ! RESTRICT GRANT COEFFICIENT TO ZERO IF EXCLUDING TREATMENT GROUP
        bl(nparam-2) = 0
        bu(nparam-2) = 0
        istate(nparam-2)=3
    endif

    testgrant = 0
    if (testgrant .eq. 1) then
        ! RESTRICT GRANT COEFFICIENT TO ZERO IF EXCLUDING TREATMENT GROUP
        bl(nparam-2) = 1
        bu(nparam-2) = 1
        istate(nparam-2)=3
    endif

    !**********************************************

    !Restricting the HABITS coefficient to be 0
    !bl(nparam)=0.d0
    !bu(nparam)= 0.d0
    !Restrict the terminal value function parameters to estimate the model with zero discount factor
    !bl(90)=1.0
    !bu(90)=1.0
    !bl(91)=1.0
    !bu(91)=1.0

    !**********************************************


    ! restricting some of the parameters
    !do ij=28,51
    !    bl(ij) = theta(ij)
    !    bu(ij) = bl(ij)
    !enddo

    !set constant to zero
    !bl(1)=0.d0
    !bu(1)=0.d0
    !write(6,*) 'flag'
    !goto 100
    !goto 10001
    theta=theta0
    !call restr(bl,bu)
    call e04uef('derivative level=0')
    call e04uef('Monitoring File=8')
    call e04uef('Major Print Level=010')
    call e04uef('Hessian=yes')
    call e04uef('Major Iteration Limit=500')

    call e04ucf(Nparam, NCLIN, NCNLN, LDA, LDCJ, LDR, A, BL, BU, costas, likel, ITER,ISTATE,&
    & C, CJAC, CLAMDA, funct, objgrad, r, theta, IWK, idim,&
    & WORK, idim1, IUSER, USER, IFAIL)

    write(7,*) ' in exiting e04ucf ifail = ',ifail
    write(7,*) '  function value = ', funct

    np=0




    do i=1,nparam
        if (istate(i) .eq. 0 ) then
            np = np + 1
        else
            write(6,*) ' param ',i , ' constrained ',istate(i)
        endif
    enddo

    write(6,*) ' there are ', np, ' free params'

    ! note that the hessian is = R'R where R is upper triangular
    do i=2,np
        do jk=1,i-1
            r(i,jk)=0
        enddo
    enddo

    hess=matmul(transpose(R),R)
    call INVERT(NP,R,COV)
    write(6,*) '  computed varcov matrix '

    !100 continue
    write(6,*) '  function value on exit = ', funct, " IFAIL= ", ifail

    write(6,*) ' params and Hessian standard errors '
    j = 0
    do i=1,nparam
        theta0(i)=theta(i)
        if (istate(i) .eq. 0) then
            j = j+1
            write(6,'(I5,2F15.5)') i,theta(i),cov(j,j)**0.5
        else
            write(6,'(I5,2F15.5)') i,theta(i)
        endif
    enddo



    do jk=1,nparam
        mscore(jk)=0.d0
    enddo


    call x05aaf(itime)
    write(6,*) ' before computing score time is ',(itime(ij),ij=1,7)

    deltar=6.5535d-05

    nder = 1
    hbase = 1.302917D-05

    ! This tells likel that it is being called for derivative calculations at one observation
    ! and which method to use
    deriva=2
    if(beta.lt.0.01) deriva=3
    if (deriva.eq.3) goto 1987

    jk = 0
    do j=1,nparam
        call x05aaf(itime)
    !write(6,*) ' param ',j ,(itime(ij),ij=1,7)
        do ii = 1,nparam
            point(ii) = theta(ii)
        enddo
        if (istate(j) .eq. 0) then
            jk = jk+1
            kkp = j
            do i=1,nobs
                observ = i
                point(j)=theta(j)
                xval = point(j)
                ifail = 0
                if (deriva.eq.1) then
                    call D04AAF(XVAL, NDER, HBASE, DER, EREST, funder, IFAIL)
                    score(i,jk) = der(1)
                endif
                if(deriva.eq.2) then
                    call orazioder(deltar,der)
                    score(i,jk) = der(1)
                endif
                mscore(jk)=mscore(jk)+score(i,jk)/nobs
            enddo
        endif
    enddo
    call x05aaf(itime)
    !           write(6,*) ' done param ',j ,(itime(ij),ij=1,7)
    !if (i.eq. 1) write(6,*) jk, nparam
    np = jk

    call x05aaf(itime)
    write(6,*) ' after computing score time is ',(itime(ij),ij=1,7)


    write(6,*) ' mean score'
!
    write(6,*) (mscore(j),j=1,np)

    !do i=1,30
    !   write(6,*) (score(i,j),j=1,np)
    !enddo
    !write(6,*) 'last'
    !   write(6,*) (score(nobs,j),j=1,np)

    open(66,file='score.dat')

    !<gslab> write scores to file
    do i=1,nobs
        write(66,*)(score(i,j),j=1,np)
    enddo
    WRITE(66,*)
    write(66,*) np
    close(66)
!
!do i = 1,nparam
!   do j = 1,i
!   a(j,i)=0.d0
!       do ij=1,nobs
!           a(j,i)=a(j,i)+score(ij,i)*score(ij,j)
!       enddo
!   enddo
!enddo


! f08aef does the QR decomposition of the score: the top np x np of score is overwritten
! with the upper triangular of the choleski decomposition

    call F08AEF(nobs, Np, score, maxobs, TAU, WORK, 21*maxpar, ifail)

    do j=1,np
        do jk=1,np
            r(j,jk)=score(j,jk)
        enddo
    enddo


    do i=1,np
        do j=i,np
            sum1 = 0
            do jk =1,i
                sum1 = sum1 + r(jk,i)*r(jk,j)
            enddo
            xxsc(i,j) = sum1
            xxsc(j,i) = sum1
        enddo
    enddo

   
    !<gslab> code (taken from INVERT.f90)
    ! Set up gslab_R
    do i=1,np
        do j=1,np
            gslab_R(i,j) = 0
        enddo
    enddo 
    do i=np,1,-1
        do j=np,i,-1
            gslab_R(i,j) = R(i,j)
        enddo
    enddo
  
    !<gslab> write hessian to file
    write(6,*) '<gslab> at gslab_hess np is ',np
    gslab_hess=matmul(transpose(gslab_R),gslab_R)
    open(77, file='gslab_hess.dat')
    do i=1,np
        write(77, *) (gslab_hess(i,j), j=1,np)
    enddo
    close(77)
    
    call INVERT(NP,R,COVsc)

    !<gslab> print out their COVSC
    open(77, file='covsc.dat')
    do i=1,np
        write(77, *) (covsc(i, j), j=1,np)
    enddo
    close(77)



! sandwich formula for the s.e.'s
    covsa=matmul(cov,matmul(xxsc,cov))

    1987 continue
    i = 0
    nparam1=nparam-Npointi*npoints+1-npoints-npointi-nparterm-useage-useyrs-useg_a


    ik1= 1
    ik2= npoints+1
    ik21=npoints+npointi+1
    ik3= npoints+npointi+1+npoints*npointi-1
    ik30=ik3+ncuts
    ik31=ik30+npeduc
    ik4=ik31+nparterm
    ik5= ik4+nconst
    ik6=ik5+nprim
    ik7=ik6+nsec

    bprob=npoints+npointi+2
    eprob=bprob+npoints*npointi-2

    jprob=1
    do jjj=1, npoints
        do kkk=1, npointi
            if (jjj.eq.npoints.and.kkk.eq.npointi) then
                continue
            else
                ppp(jprob)=probp(jjj,kkk)
                jprob=jprob+1
            end if
        enddo
    enddo

    do jjj = 1,eprob-bprob+1
        do kkk = 1,eprob-bprob+1
            vprob(jjj,kkk)=cov(bprob+jjj-1,bprob+kkk-1)
            vprobsc(jjj,kkk)=covsc(bprob+jjj-1,bprob+kkk-1)
            vprobsa(jjj,kkk)=covsa(bprob+jjj-1,bprob+kkk-1)

        if(jjj.eq.kkk) then
            gprob(jjj,kkk)=ppp(jjj)*(1-ppp(jjj))
        else
            gprob(jjj,kkk)=-ppp(jjj)*ppp(kkk)
        endif


        enddo
    enddo

    vp=matmul(gprob,matmul(vprob,gprob))
    vpsc=matmul(gprob,matmul(vprobsc,gprob))
    vpsa=matmul(gprob,matmul(vprobsa,gprob))

    i = 0
    do j = 1, nparam

    if (j.le.ik1) iJ=100
    if (j.gt.ik1.and.j.le.ik2) iJ = 101
    if (j.gt.ik2.and.j.le.ik21) iJ = 102

    if (j.gt.ik21.and.j.le.ik3) ij=  103
    if (j.gt.ik3.and.j.le.ik30) ij = 222
    if (j.gt.ik30.and.j.le.ik31) ij= 777
    if (j.gt.ik31.and.j.le.ik4.and.nparterm.gt.0) ij=  111

    if (j.gt.ik4.and.j.le.ik5) iJ = nposc(j-ik4)
    if (j.gt.ik5.and.j.le.ik6) iJ = nposp(j-ik5)
    if (j.gt.ik6.and.j.le.ik7) iJ = nposs(j-ik6)
    if (j.gt.ik7) ij=99

    if( j.gt.ik7.or.ij.gt.100)  then
        icou=nconst+ik1+nprim+nsec
        if(ij.eq.100) nvar="consted"
        if(ij.eq.101) nvar="constin"
        if(ij.eq.102) nvar="constsl"
        if(ij.eq.777) nvar="educeq"
        if(ij.eq.103) nvar="probs"
        if(ij.eq.222) nvar="cutoffs"
        if(ij.eq.103) nvar="prob"
        if(ij.eq.111) nvar="term"
        if (j.gt.ik2.and.j.le.ik21) nvar="wage"
        if (j.eq.ik7+1) nvar= "grant"
        if (j.eq.ik7+2.and.useage.eq.1) nvar="age"
        if (j.eq.ik7+2+useage.and.useg_a.eq.1) nvar="agegrant"
        if (j.eq.ik7+2+useage+useg_a.and.useyrs.eq.1) nvar="edyrs"

!       i=j
        IF (ISTATE(J) .eq. 0) THEN
            i=i+1
            sumsc=covsc(i,i)**0.5
            sum1 = cov(i,i)**0.5
            sumsa=covsa(i,i)**0.5
            WRITE(6,'(a10,1I10,5F15.5)') nvar,I,theta(J), sumsc
            WRITE(7,'(a10,1I10,5F15.5)') nvar,I,theta(J), sumsc
        ELSE
            WRITE(6,'(a10,1I10,5F15.5)') nvar,I,theta(J)
            WRITE(7,'(a10,1I10,5F15.5)') nvar,I,theta(J)
        ENDIF
    else
        IF (ISTATE(J) .eq. 0) THEN
            i=i+1
            sumsc=covsc(i,i)**0.5
            sum1 = cov(i,i)**0.5
            sumsa=covsa(i,i)**0.5
            WRITE(6,'(2I10,5F15.5)') IJ,I,theta(J),sumsc
            WRITE(7,'(2I10,5F15.5)') IJ,I,theta(J),sumsc
        ELSE
            WRITE(6,'(2I10,5F15.5)') IJ,I,theta(J)
            WRITE(7,'(2I10,5F15.5)') IJ,I,theta(J)
        ENDIF
    endif
!                           write(6,*) i, cov(i,i)
enddo

do j=1,npointi
    pj(j)=0.d0
    !do ie=1,npointe
    do i=1,npoints
        pj(j)=pj(j)+probp(i,j)
    enddo
enddo

!enddo
do i=1,npoints
    pi(i)=0.d0
    do j=1,npointi
        !do ie=1,npointe
        !pi(i)=pi(i)+probp(i,j,ie)
        !enddo
    enddo
enddo

uno=1.d0
write(6,*) '  matrix of probabilities for the unobserved heterogeneity factors '
write(6,*) ' rows is interecept points, columns is slope points'
write(7,*) '  matrix of probabilities for the unobserved heterogeneity factors '
write(7,*) ' rows is interecept points, columns is slope points'

!do ie=1,npointe
write(6,*) '  matrix of probabilities for the unobserved heterogeneity factors '
write(6,*) ' rows is interecept points, columns is slope'
write(7,*) '  matrix of probabilities for the unobserved heterogeneity factors '
write(7,*) ' rows is interecept points, columns is slope'

!write(6,*) ' education point ' , ie
!write(7,*) ' education point ' , ie

do i=1,npoints
    write(6,1969)  (probp(i,j),j=1,npointi),pi(i)
    write(7,1969)  (probp(i,j),j=1,npointi),pi(i)
enddo
write(6,1969) (pj(j),j=1,npointi),uno
write(7,1969) (pj(j),j=1,npointi),uno

!enddo
!
1969 format(10(1x,f6.4))

write(6,*) ' probabilities with s.e. s computed by delta method'
write(6,*) ' probabilities with s.e. s computed by delta method'

do jjj=1,npoints*npointi-1
    sumsc=vpsc(jjj,jjj)**0.5
    sum1 = vp(jjj,jjj)**0.5
    sumsa=vpsa(jjj,jjj)**0.5
    write(6,'(1I10,5F15.5)') jjj, ppp(jjj), sum1,sumsc,sumsa
    write(7,'(1I10,5F15.5)') jjj, ppp(jjj), sum1,sumsc,sumsa
enddo




!write(6,*) ' *********** VT as a function of education and its return by state ********'
!write(7,*) ' *********** VT as a function of education and its return by state ********'
!write(6,*) '  state  grade  wages   VT'
!write(6,*) '  state  grade  wages   VT'
!do ie=1,7
!do i=1,nschool
!write(6,1959) ie,i,wfinal(i,ie),VT(i,ie)
!write(7,1959) ie,i,wfinal(i,ie),VT(i,ie)
!enddo
!enddo
1959 format(1x,2i6,2f12.4)


!theta0=theta

!call nag_nlp_sol(likelihood,theta,funct,obj_deriv,obj_grad, &
!               & x_lower=x_lower,x_upper=x_upper, &
!              & control=control, &
!              & error=error)


!     nag_nlp_sol(obj_fun,x,obj_f,      num_nlin_con=num_nlin_con, &
!       con_fun=con_fun,x_lower=x_lower,x_upper=x_upper,nlin_lower=nlin_lower, &
!       nlin_upper=nlin_upper)

!10001 call eval(theta0)
write(6,*) ' ibeta= ' , ibeta, ' discfact = ', ndiscfact
enddo
10001 continue
!the parameters are read from paramsh.dat as theta0. Don't forget to put final parameter values in paramsh.dat
call eval(theta0)

end
