# Divergence

This repository is modeled after [v4.1.1 of the GSLab Template](https://github.com/gslab-econ/template/tree/v4.1.1). Prerequisites listed below are in addition to those listed in the template. 

The currect version of gslab_python can be installed via: 
`pip install git+ssh://git@github.com/gslab-econ/gslab_python.git@v4.1.0`

Requirements for `paper_slides/`
- None beyond [Template prerequisites](https://github.com/gslab-econ/template/tree/v4.1.1). 

Requirements for `analysis/`
- MATLAB, with...
    - [gslab_matlab](https://github.com/gslab-econ/gslab_matlab)
    - The ability to compile C MEX files.
- Stata and the [gslab_misc](https://github.com/gslab-econ/gslab_stata/tree/e148ca63ae532fffc45121fdfe0d9b593f9bed29) 
  Stata package.
- R and the R package `mixtools`
- - Mac OS X `bash` and [ffmpeg](https://ffmpeg.org/download.html) to compile our gif figures

Note: This directory's commands cannot be run in parallel using SCons's `-j` option,
as this option is incompatible with `gslab_scons.build_matlab()`.
