drop _all
cap log c
set mem 200m
u redform2
 cap drop mil 
cap drop pprob
cap drop pp 

cap drop progresa
gen progresa = A+B
log using newwage_2.log, replace
cap drop cwork
gen cwork = 0 
replace cwork =1 if lhw~=.
replace cwork=. if age<=8 
replace cwork=. if hw>=90 & hw~=.
gen dist97_2=dist97^2
gen dist98_2=dist98^2



cap log c
log using wages_new.log, replace
/*  old variables probit */
probit school A B D order age a2 grant fate1 fate3-fate6 mote1 mote3-mote6 faho moho indig denti* kmsec sec97 prim97 sec98 prim98 , cluster(town)
test sec97 prim97
cap drop pps
predict pps, xb
cap drop pprobs
predict pprobs
cap drop milso
gen milso= normalden(pps)/pprobs

probit cwork A B D order age a2 grant fate1 fate3-fate6 mote1 mote3-mote6 faho moho indig denti* kmsec sec97 prim97 sec98 prim98,cluster(town) 
test sec97 prim97
cap drop pp
predict pp, xb
cap drop pprob
predict pprob
cap drop milo
gen milo= normalden(pp)/pprob


/* new variables probits */


probit school A B D order age a2 grant fate1 fate3-fate6 mote1 mote3-mote6 faho moho indig denti* dist98 dist97 dist98_2 dist97_2 sec97_m prim97 sec98_m prim98 , cluster(town)
test dist97 dist97_2 sec97_m prim97 
test dist98 dist98_2 sec98_m prim98

probit school A B D order age a2 grant fate1 fate3-fate6 mote1 mote3-mote6 faho moho indig denti* dist98 dist97   sec97_m prim97 sec98_m prim98 , cluster(town)
test sec97_m prim97 dist97  
cap drop pps
predict pps, xb
cap drop pprobs
predict pprobs
cap drop mils
gen mils= normalden(pps)/pprobs
probit cwork A B D order age a2 grant fate1 fate3-fate6 mote1 mote3-mote6 faho moho indig denti* dist97 dist98 dist98_2 dist97_2 sec97_m prim97 sec98_m prim98,cluster(town) 
test dist97 dist97_2 prim97 sec97_m
probit cwork A B D order age a2 grant fate1 fate3-fate6 mote1 mote3-mote6 faho moho indig denti* dist97  dist98 sec97_m prim97 sec98_m prim98,cluster(town) 

test sec97_m dist97 prim97  
cap drop pp
predict pp, xb
cap drop pprob
predict pprob
cap drop mil
gen mil= normalden(pp)/pprob


/* old measures */
reg lhw lwag age yrs progresa prim98 sec98 kkmsec mminsec kkprim  milo if hw<90 & age>8, cluster(town)
reg lhw lwag age yrs progresa prim98 sec98 kmsec mminsec kkprim  milo if hw<90 & age>8, cluster(town)
reg lhw lwag age yrs progresa prim98 sec98 kkmsec mminsec kkprim  milso if hw<90 & age>8, cluster(town)
reg lhw lwag age yrs progresa prim98 sec98 kmsec mminsec kkprim  milso if hw<90 & age>8, cluster(town)

/*  now new measures from Matteo */

reg lhw lwag age yrs progresa prim98 sec98_m dist98 mils if hw<90 & age>8, cluster(town)
reg lhw lwag age yrs progresa prim98 sec98_m dist98 mil if hw<90 & age>8, cluster(town)

reg lhw lwag age yrs progresa prim98 sec98_m dist98 dist98_2 mils if hw<90 & age>8, cluster(town)
reg lhw lwag age yrs progresa prim98 sec98_m dist98 dist98_2 mil if hw<90 & age>8, cluster(town)


reg lhw lwag age yrs progresa  dist98 mils if hw<90 & age>8, cluster(town)
reg lhw lwag age yrs progresa  dist98 mil if hw<90 & age>8, cluster(town)



reg lhw lwag age yrs progresa mils if hw<90 & age>8, cluster(town)
reg lhw lwag age yrs progresa mil if hw<90 & age>8, cluster(town)




log c
