% Matthew Gentzkow
% February 27, 2002
%
% function changes

function chg = changes(choices,C)

n = size(choices);
t = size(C,2);
chg = zeros(2,2);

edges = cumsum(ones(2,1))-1;
for i = 1:n
	count = histc(C(i,:)',edges);
	shares = count./repmat(sum(count),2,1);
   if choices(i)==2
      chg(:,1) = chg(:,1)+shares;
   end
   if choices(i)==3
      chg(:,2) = chg(:,2)+shares;
   end
end

chg = chg./repmat(sum(chg,1),2,1);
