# Run the AMS-provided makefiles to compile Fortran programs
make clean
make all

# Make the output directory
mkdir -p ../../../../build/analysis/ams_2011/counterfactual/

# Move compiled programs
for f in *.o *.mod ./main_PNP 
do
    mv $f ../../../../build/analysis/ams_2011/counterfactual/$f
done

# Copy the parameters file and our sbatch file
for f in PARAM_OA_PNP_eval.out
do
    cp $f ../../../../build/analysis/ams_2011/counterfactual/$f
done

# Run the simulation.
cd ../../../../build/analysis/ams_2011/counterfactual/
./main_PNP
