# HOW TO RUN AMS: 

- Run the SConscript **locally** for `build/analysis/ams_2011` first by running `python run.py build/analysis/ams_2011/score_hessian` in the root. This builds the necessary files for subsequent calculation

- Log in to your Sherlock account, go to `/home/groups/gentzkow` and then create your own folder there `mkdir USERNAME`. 

- Git clone `divergence` repo in the newly created directory. Make a new sub-directory by `mkdir divergence/analysis/build/analysis`.

- Now transfer **rsync** everything in `build/analysis/ams_2011` to the corresponding directory on Sherlock by `rsync -arv build/analysis/ams_2011 USERNAME@sherlock.stanford.edu:/home/groups/gentzkow/USERNAME/divergence/analysis/build/analysis` 

- You have to run the sub-folders separately: 
	- `replication`: go into the folder and then run `sh compile_and_run.sh`
	- `counterfactual`: stay in the root run `sbatch source/analysis/ams_2011/counterfactual/AMS.sbatch`
	- `score_hessian`: go into the folder and then run `python run.py`

- Transfer back **rsync** everything in `build/analysis/ams_2011` on sherlock to the corresponding local directory. 

- The remaining folders (i.e. `informativeness`, `experiment` and `notes`) can be run locally via `scons`. 



