# Load the required Sherlock modules.
module load ifort
module load nagfl

# Link the lnag_nag paths to your shell environment.
LD_LIBRARY_PATH=lib:/share/sw/licensed/nag/mark24/fll6i24dcl/acml:${LD_LIBRARY_PATH}
LD_LIBRARY_PATH=/share/sw/licensed/nag/mark24/fll6i24dcl/${LD_LIBRARY_PATH}

# Run the AMS-provided makefiles to compile Fortran programs
make clean
make all

# Move compiled programs
for f in *.o *.mod ./main_PNP 
do
    mv $f ../../../../build/analysis/ams_2011/replication/$f
done
# Copy the parameters file and our sbatch file
for f in PARAM_OA_PNP_eval.out
do
    cp $f ../../../../build/analysis/ams_2011/replication/$f
done

# Run the sbatch file.
cd ../../../../build/analysis/ams_2011/replication/
./main_PNP

