       SUBROUTINE INVERT(NP,UMATRIX,COV)
			  use paramglo

        implicit none
       real*8, parameter::zero=0.000001
!       INVERT BY BACK SUBSTITUTION A MATRIX THAT HAS BEEN
!       DECOMPOSED BY CHOLESKY DECOMPOSITION. USE THE UPPER TRIANGLE.
!       Matrix to be inverter = umatrix'umatrix and umatrix is upper triangular.
!       Inverse goes into COV

!        INTEGER MAXP
        REAL*8 UMATRIX(MAXPAR1,*), D(MAXPAR1), SUM, COV(MAXPAR1,*)
        INTEGER I, J, NP, Q, K

!       ********TESTING*********
!	   WRITE(6,'(A)') ' R transposed '
!       DO I=1,NP
!           WRITE(6,'(5G16.8)')(UMATRIX(I,J),J=1,I)
! 	   enddo
!       WRITE(6,'(4G16.8)') (D(I),I=1,NP)
!       WRITE(6,'(A,3I6)') ' NP ,MAXPAR1',NP,MAXPAR1
!       *********** END TESTING ************
    do i=np,1,-1
			do j=np,i,-1
				if(i.eq.j) d(i) =umatrix(i,j)**2
				umatrix(i,j) = umatrix(i,j)/umatrix(i,i)
			enddo
		enddo


        DO 800 I=NP,1,-1
               DO 800 J=NP, I, -1
                    IF ( I .EQ. J ) THEN
                       SUM = D(I)
                       IF (ABS(SUM) .LT. ZERO) THEN
                           SUM = 1.0/ZERO
                       ELSE
                           SUM = 1.0/SUM
                       ENDIF
                    ELSE
                       SUM = 0.0
                    ENDIF
                    Q=I+1
                    DO 900 K=Q,NP
                       SUM=SUM-UMATRIX(I,K)*COV(K,J)
900                 CONTINUE
                    COV(I,J)=SUM
                    COV(J,I)=SUM
800            CONTINUE
!        DO 100 I=1,NP
!           DO 100 J=1,NP
!              UMATRIX(I,J)=COV(I,J)
!100     CONTINUE

!write(6,*) ' cov '

!do i=1,3
!write(6,100) (cov(i,j), j=1,3)
!enddo


!write(6,*)(d(i),i=1,np)

100 format(3f8.2)


RETURN
END

