subroutine readdata
use proglo
implicit none
integer:: i,k,j,ncelv,ia,iv,ig,esta,ie, ic, npeducv, npeduci,  ij, ij1
real*8:: xxxx
!real*8 cutoff(final-selage,nschool)
 character*20 datafile, OUTPUTFI
! progresdat.dat contains free format data on enrollment,age, costs etc. the unit is the child
! returndat.dat contains the 'return to education data'
! village.dat contains data on costs by village
! params.dat contains data on the problem


!			OPEN(12,FILE='progresdat.dat',status='old')
! OPEN(11,FILE='returndat.dat',status='old')
OPEN(13,FILE='villagen.dat',status='old')
OPEN(14,FILE='kidwage4.dat',status='old')
open(24,file='Spassot.raw',status='old')


!open(10,file='PARAM_PPNP_notreat_eval.out',status='old')
!open(10,file='PARAM_OA.out',status='old')    ! No Progresa dummy
!open(10,file='PARAM_OA_eval.out',status='old')
!open(10,file='PARAM_OA_PPNP.out',status='old')    ! Progresa dummy
!open(10,file='PARAM_OA_PPNP_eval.out',status='old')
!open(10,file='PARAM_OA_PNP_test.out',status='old')    ! with  PROGRESA non-eligible dummy
! open(10,file='PARAM_OA_PNP.out',status='old')    ! with  PROGRESA non-eligible dummy
open(10,file='PARAM_OA_PNP_eval.out',status='old') ! GSLab modification: we now exclusively use this param file
!open(10,file='PARAM_OA_notreat.out',status='old')  ! On controls alone
!open(10,file='PARAM_OA_notreat_eval.out',status='old')

! These are for the simulations
!open(77,file='SIMUL_OA.out')
open(77,file='SIMUL_OA_PNP.out')
!open(77,file='SIMUL_OA_PPNP.out')
!open(77,file='SIMUL_PPNP_notreat.out')


open(8,  file='monitor_iterations')
open(6,  file='t85_check.out')
open(192,file='obs_identifier.out')

! write(6,*) maxgrade-1, final-6
do i=1,maxgrade-1
    !do j=1,final-6
     read(24,*) (tramx(i,j),j=1,final-6)
     !tramx(i,j)=1.0
     !enddo
enddo

       read(10,*) datafile
       READ(10,*) OUTPUTFI
read(10,*) estimat , notreat

if (estimat .eq. 0) notreat = 0 !When we simulate we keep all the data in

print*, datafile
OPEN(12,FILE=datafile,status='old')
OPEN(7,FILE=OUTPUTFI)
read(10,*) nobs ! number of children

read(10,*) nvars      ! total number of vars in children dataset

!write(6,*) ' flag02', nvars
      read(10,*) nvil       ! number of villages
!write(6,*) 'flag03' , nvil
read(10,*) nvilvar    ! number of vars in village dataset
! number of cost variables: child spec., primary, secondary, number of vars in educ model
read(10,*) nconst,nprim,nsec
read(10,*) npeducv,npeduci
npeduc = npeducv+npeduci


!   npoints is the number of points of support for unobs heterog in intercept
!		read(10,*) npoints
!   npoints is the number of points of support for unobs heterog in slope
!		read(10,*) npointi

write(6,*) 'points of support for unobserv. het. in intercept and slope =', npoints, npointi
write(7,*) 'points of support for unobserv. het. in intercept and slope =', npoints, npointi
write(6,*) 'Selecting out children younger than ',selage
write(6,*) ' notreat (1 exclude treatment villages, zero include treatment villages), notreat=', notreat
write(7,*) 'Selecting out children younger than ',selage

!useage determines whether we want age in the cost matrix (o or 1)
!      read(10,*) npoints



read(10,*) useage
read(10,*) useyrs
read(10,*) selage   ! Selects out kids younger than selage

!  useg_a allows for an interaction between grant and age
read(10,*) useg_a


read(10,*) nparterm
!Number of parameters in terminal value function


write(6,*) ' number of parameters in the value function = ',nparterm
write(7,*) ' number of parameters in the value function = ',nparterm

write(6,*) ' number of parameters in education reduced form = ',npeduc
write(7,*) ' number of parameters in education reduced form = ',npeduc

	!  cons_g is used to constraint the grant effect to be the same
    ! as the 100 unconditional pesos the beneficiaries receive

!number of years in which the program will
!be implemented in the control villages

read(10,*) nyrscp
read(10,*) betadj
write(6,*) ' it is assume the program is implemented in the control villages in ',nyrscp,' years'
write(7,*) ' it is assume the program is implemented in the control villages in ',nyrscp,' years'

write(6,*) 'Selecting out children younger than ',selage
write(7,*) 'Selecting out children younger than ',selage

write(6,*) ' beta adjustment = ', betadj
write(7,*) ' beta adjustment = ', betadj

write(6,*) '        useage    useyrs    useg_a    nparterm      cons_gr     nyrscp'
write(7,*) '        useage    useyrs    useg_a    nparterm      cons_gr     nyrscp'
read(10,*) cons_gr
read(10,*) progin
write(6,*) useage, useyrs, useg_a, nparterm, cons_gr, nyrscp
write(7,*) useage, useyrs, useg_a, nparterm, cons_gr, nyrscp
read(10,*) lowerage
! ncelv gives the total number of obs in the dataset containing kids
!                               wages by village, age and grade
     ncelv=maxgrade*(final-5)*nvil
!positions of the variables indicating enrollment status, age, grade and village of residence
!                        and whether the child belongs to a progresa beneficiary household
read(10,*) nestado,npose,nposa,nposg, nvilchi, npb , nnpb

! positions of the variables indicating child spec, primary and secondary costs
if(nconst .gt. 0)read(10,*) (nposc(j),j=1,nconst)
if(nprim  .gt. 0)read(10,*) (nposp(j),j=1,nprim)
if(nsec   .gt. 0)read(10,*) (nposs(j),j=1,nsec)
if(npeducv  .gt. 0)read(10,*) (nposeducv(j),j=1,npeducv)
if(npeduci  .gt. 0)     read(10,*) (nposeduci(j),j=1,npeduci)

!write(6,*)' beta = ', beta
write(6,*) 'this run will have in cost:'
write(6,*) nconst, ' child specific variables  '
write(6,*) nprim, ' primary school cost variables'
write(6,*) nsec, ' secondary school cost variables'
write(7,*) 'this run will have in cost:'
write(7,*) nconst, ' child specific variables  '
write(7,*) nprim, ' primary school cost variables'
write(7,*) nsec, ' secondary school cost variables'
if(nconst .gt. 0)write(6,*) ' child specific costs are: ', (nposc(j),j=1,nconst)
if(nprim  .gt. 0)write(6,*) ' primary school costs are: ', (nposp(j),j=1,nprim)
if(nsec   .gt. 0)write(6,*) ' sec. school costs are: ',(nposs(j),j=1,nsec)
if(nconst .gt. 0)write(7,*) ' child specific costs are: ', (nposc(j),j=1,nconst)
if(nprim  .gt. 0)write(7,*) ' primary school costs are: ', (nposp(j),j=1,nprim)
if(nsec   .gt. 0)write(7,*) ' sec. school costs are: ',(nposs(j),j=1,nsec)
if(npeducv.gt. 0)   write(6,*) ' village variables in education model: ',(nposeducv(j),j=1,npeducv)
if(npeduci.gt. 0)   write(6,*) ' indiv. variables in education model: ',(nposeduci(j),j=1,npeduci)
if(npeducv.gt. 0)   write(7,*) ' village variables in education model: ',(nposeducv(j),j=1,npeducv)
if(npeduci.gt. 0)   write(7,*) ' indiv. variables in education model: ',(nposeduci(j),j=1,npeduci)


if(useage.eq.1) write( 6,*) ' age is included in the cost matrix'
if(useage.eq.1) write( 7,*) ' age is included in the cost matrix'
if(useage.eq.0) write( 6,*) ' age is excluded from the cost matrix'
if(useage.eq.0) write( 7,*) ' age is excluded from the cost matrix'
if(useyrs.eq.1) write( 6,*) ' yrs is included in the cost matrix'
if(useyrs.eq.1) write( 7,*) ' yrs is included in the cost matrix'
if(useyrs.eq.0) write( 6,*) ' yrs is excluded from the cost matrix'
if(useyrs.eq.0) write( 7,*) ' yrs is excluded from the cost matrix'

do i=1,nvil
    read(13,*) (xv(i,j),j=1,nvilvar)
enddo
!write(6,*) ' flag0'
i = 0
do ic=1,nobs
    !if(i.le.30) write(6,*) i
    read(12,*) (tempx(j),j=1,nvars)
    !The first selection relates to age of the child. The second to whether we will use the treatment villages or not
    if (tempx(nposa) .lt. selage .or. tempx(nposa) .gt. 16 .or.(notreat .eq. 1) .and. (abs(tempx(14)-1.0) .LT. zero )) then

        continue ! i.e skip the observation

    else
        i = i+1
        do j = 1,nvars
           x(i,j) = tempx(j)
        enddo
        enrol(i)=x(i,npose)
        age(i)=x(i,nposa)
        grade(i)=x(i,nposg)
        village(i)=x(i,nvilchi)
        benef(i)=x(i,npb)
        fben(i)=x(i,nnpb)
        !   progresa variable should be 14
        progresa(i)=x(i,14)
        esta=x(i,nestado)
        if(esta.eq.12) estado(i)=1
        if(esta.eq.13) estado(i)=2
        if(esta.eq.16) estado(i)=3
        if(esta.eq.21) estado(i)=4
        if(esta.eq.22) estado(i)=5
        if(esta.eq.24) estado(i)=6
        if(esta.eq.30) estado(i)=7

        write(192, *) x(i,1), ",", x(i,10)

        !if(i.le.30) write(6,*) i,'  2'
        if ( npeduci.gt.0) then
           do k=1,npeduci
              xeduc(i,k)=x(i,nposeduci(k))
           enddo
        endif
        if ( nconst.gt.0) then
            do k=1,nconst
                xconst(i,k)=x(i,nposc(k))
            enddo
        endif
        if ( nprim.gt.0) then
            do k=1,nprim
                xprim(i,k)=xv(village(i),nposp(k))
            enddo
        endif
        if(nsec.gt.0) then
            do k=1,nsec
                xsec(i,k)=xv(village(i),nposs(k))
            enddo
        endif
        if ( npeducv.gt.0) then
           do k=1,npeducv
              xeduc(i,npeduci+k)=xv(village(i),nposeducv(k))
           enddo
        endif
    endif !select
enddo ! reading individual data

write(6,*) ' Number of observations read ', nobs
write(7,*) ' Number of observations read ', nobs
nobs = i  ! Overwrite number of observations with the number actually used after selection
write(6,*) ' Number of observations selected ', nobs
write(7,*) ' Number of observations selected ', nobs

close(192)

!write(6,*) ' flag1'

!do until age>=17;
!age=age+1;
!yrs =0;
!do until yrs >= age-5;

!  read data on wage kids by village
do iv =1,nvil
do ia =1,final-6
do ig=1,ia
    read(14,*) k,j,i,xxxx
    !write(6,*) iv,ia,ig
    wage(k,j-5,i)=xxxx

enddo
enddo
enddo
! read the data on return to education - AVERAGE OF COUNTRY FIRST
do ie=1,8
     read(10,*) retp(ie),retpcom(ie),rets(ie),retscom(ie), xxxx
     wfinal(1,ie)=xxxx
!    write(6,*) ' flag2'
enddo
do ie=1,7
do i=2,maxgrade-1
    !if(i.le.iprim) then
    !wfinal(i,ie)=wfinal(i-1,ie)*(1+retp(ie+1))
    !else
    !    if(i.eq.iprim+1) then
    !      wfinal(i,ie)=wfinal(1,ie)*((1+retpcom(ie+1))**iprim)
    !    else
    !      wfinal(i,ie)=wfinal(1,ie)*((1+rets(ie+1))**i)
    !    endif
    !endif
    wfinal(i,ie)=wfinal(1,ie+1)*((1+retscom(ie+1))**(i-1))
enddo
      wfinal(maxgrade,ie)=wfinal(1,ie+1)*((1+retscom(ie+1))**(maxgrade-1))
enddo
! 2 comes from parameter on grant : the constant and the wage parameter
!  are in the unobserved heterogeneity.
!  useage adds age as a cost variable
!npeduc : number of right hand side variables in education model excluding intercept/heterogeneity

ncuts=0
do ie=selage,final-1
ncuts=ncuts+ie-6
!nc(ie-selage+1)=ie-6
enddo



nparam=nprim+nsec+nconst+1+useage+useyrs+(npoints*npointi-1)+  &
&   npoints+npointi +useg_a+nparterm + npeduc+ncuts+1

! read initial values for the parameters
write(6,*) ' initial values of the params ', nparam, ncuts
do k=1,nparam

  read(10,*) theta0(k)
  write(6,201) k,theta0(k)
enddo
write(6,*) 'read initial values'
! now transform the initial values of the cutoff points so that they are in terms of increments

ij=npoints+npointi+1+(npoints*npointi)

! Now parameters in the education equation
ij1=0
do i=selage,final-1
do j=1,i-6
if(j.eq.1) then
cutoff(i-selage+1,j)=theta0(ij+ij1)
else
!theta0(ij+ij1)=log(theta0(ij+ij1)-cutoff(i-selage+1,j-1))
cutoff(i-selage+1,j)=cutoff(i-selage+1,j-1)+dexp(theta0(ij+ij1))
endif
ij1=ij1+1
enddo
enddo





close(10)

201 format(i6,f10.5)

return
end
