#! /usr/bin/env python
#****************************************************
# GET LIBRARY
#****************************************************
import subprocess, shutil, os
gslab_make_path = os.getenv('gslab_make_path')
subprocess.call('svn export --force -r 34822 ' + gslab_make_path + ' gslab_make', shell = True)
from gslab_make.py.get_externals import *
from gslab_make.py.make_log import *
from gslab_make.py.run_program import *
from gslab_make.py.dir_mod import *

#****************************************************
# MAKE.PY STARTS
#****************************************************

# SET DEFAULT SETTINGS
set_option(makelog   = 'log/make.log', 
          output_dir = './log', 
          temp_dir   = './program/c files/mexmaci64')

clear_dirs('./program/c files/mexmaci64')
start_make_logging()

# COMPILE MEX FILES
run_matlab(program = 'program/mexall')

end_make_logging()

shutil.rmtree('gslab_make')
raw_input('\n Press <Enter> to exit.')
